#pragma once
//==========================================================================
// FoldableWindow.h
//   ܂Ȃ\EChE@\
//==========================================================================

#include "MathUtil.h"
class WindowBacking;



//
// gbvxEChEZŎOɂ̂珇ɗ
//

class TopLevelWindowList
{
public:
	TopLevelWindowList();

	vector<HWND>::const_iterator begin() const { return theList.begin(); }
	vector<HWND>::const_iterator   end() const { return theList.end(); }
	size_t                        size() const { return theList.size(); }
	bool                         empty() const { return theList.empty(); }
	const HWND    operator[]( size_t i ) const { return theList[i]; }

private:
	static BOOL CALLBACK EnumWindowsProc( HWND wnd, LPARAM lp );
	static bool shouldBeIgnored( HWND wnd );

private:
	vector<HWND> theList;
};





struct CUSTOMVERTEX{
    FLOAT x, y, z, rhw;
    D3DCOLOR color;
	FLOAT tu, tv;
};
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_TEX1)


//
// ܂Ȃlp
//

class FoldedRect
{
private:
	dcomp V[5]; // `̒_
	bool folded;

public:
	FoldedRect() {}
	FoldedRect( const RECT& pos )
	{
		V[0] = dcomp(pos.left, pos.top);
		V[1] = dcomp(pos.right, pos.top);
		V[2] = dcomp(pos.right, pos.bottom);
		V[3] = dcomp(pos.left, pos.bottom);
		V[4] = V[0];
		folded = false;
	}

	// p  d ɂ̂т钼BE܂č̏ɎĂC[W
	dcomp pf, df;
	bool isInside( const dcomp& p ) const
	{
		return arg( (p-pf) / df ) >= 0;
	}

	int isNearEdge( const dcomp& p ) const;
	void foldBegin( const dcomp& p );
	bool foldContinue( const dcomp& p, const dcomp& q );
	void foldClear();
	bool is_folded() const { return folded; }
	double current_shape( vector<dcomp>& base, vector<dcomp>& uras ) const;
	double current_shape( vector<POINT>& base, vector<POINT>& uras ) const
	{
		// doubleWXN[W֕ϊ
		vector<dcomp> base_d, uras_d;
		const double perc = current_shape( base_d, uras_d );

		base.resize( base_d.size() );
		for(int i=0; i!=base.size(); ++i)
		{
			base[i].x = long(base_d[i].real() - V[0].real());
			base[i].y = long(base_d[i].imag() - V[0].imag());
		}

		uras.resize( uras_d.size() );
		for(int i=0; i!=uras.size(); ++i)
		{
			uras[i].x = long(uras_d[i].real());
			uras[i].y = long(uras_d[i].imag());
		}

		return perc;
	}
	void current_inner_ura_poly( vector<POINT>& pts ) const;

	bool get_orime( dcomp& p1, dcomp& p2 ) const;
	bool rebend( const dcomp& p1, const dcomp& p2 );

	bool covers( const dcomp& pt ) const;
	bool rect_covers( const dcomp& p ) const;



	// test
	void current_ura_shape( vector<CUSTOMVERTEX>& verts ) const
	{
		bool inside[] = {
			isInside(V[0]),
			isInside(V[1]),
			isInside(V[2]),
			isInside(V[3]),
			isInside(V[4]),
		};
		for(int i=0; i!=4; ++i)
		{
			if( !inside[i] )
			{
				// V[i]  (pf,df) ɊւđΏۂɐ܂ʒu
				dcomp v = conj((V[i]-pf) / df) * df + pf;

				CUSTOMVERTEX cv = {
					(float)v.real(), (float)v.imag(), 0.5f, 1.0f, 0xFFFFFFFF,
						(i==0||i==3 ? 1.0f : 0.0f), (i>=2 ? 1.0f : 0.0f)
				};
				verts.push_back( cv );
			}
			if( inside[i] && !inside[i+1]   ||   !inside[i] && inside[i+1] )
			{
				dcomp pq = V[i];
				dcomp dq = V[i+1] - V[i];
				dcomp v = line_line_cross_pt( pf, df, pq, dq );

				CUSTOMVERTEX cv = {
					(float)v.real(), (float)v.imag(), 0.5f, 1.0f, 0xFFFFFFFF,
						(v.real()-V[2].real()) / (V[0].real()-V[2].real()),
						(v.imag()-V[0].imag()) / (V[2].imag()-V[0].imag()),
				};
				verts.push_back( cv );
			}
		}
		reverse( verts.begin(), verts.end() );
	}
	HRGN current_ura_cut( HRGN rgn ) const
	{
		bool inside[] = {
			isInside(V[0]),
			isInside(V[1]),
			isInside(V[2]),
			isInside(V[3]),
			isInside(V[4]),
		};
		vector<POINT> uras;

		dcomp crs1, crs2; int j=0;
		for(int i=0; i!=4; ++i)
		{
			if( ! inside[i] )
			{
				POINT v = {(long)V[i].real(), (long)V[i].imag()};
				uras.push_back( v );
			}
			if( inside[i] && !inside[i+1]   ||   !inside[i] && inside[i+1] )
			{
				dcomp pq = V[i];
				dcomp dq = V[i+1] - V[i];
				dcomp crs = line_line_cross_pt( pf, df, pq, dq );
				(j++==0 ? crs1 : crs2) = dcomp((long)crs.real(), (long)crs.imag());
				POINT v = {(long)crs.real(), (long)crs.imag()};
				uras.push_back( v );
			}
		}
		if( real((crs2-pf)/df) < real((crs1-pf)/df) )
			swap(crs1,crs2);

		// 1st rgn
		HRGN tmp = ::CreatePolygonRgn( &uras[0], uras.size(), WINDING );
		::OffsetRgn( rgn, (int)V[0].real(), (int)V[0].imag() );
		::CombineRgn( tmp, rgn, tmp, RGN_AND );
		::OffsetRgn( rgn, -(int)V[0].real(), -(int)V[0].imag() );

		// get data
		int nBytes = ::GetRegionData( tmp, 0, NULL );
		RGNDATA* rd = reinterpret_cast<RGNDATA*>( new BYTE[nBytes] );
		::GetRegionData( tmp, nBytes, rd );

		// transform
		dcomp ppf = (j==2 ? crs1 : pf), ddf = (j==2 ? crs2-crs1 : df);
		dcomp pt00 = conj((dcomp(0,0)-ppf) / ddf) * ddf + ppf;
		dcomp pt10 = conj((dcomp(1,0)-ppf) / ddf) * ddf + ppf;
		dcomp pt01 = conj((dcomp(0,1)-ppf) / ddf) * ddf + ppf;
		pt10 -= pt00;
		pt01 -= pt00;

		XFORM t;
		t.eM11 = (float)pt10.real();  t.eM21 = (float)pt01.real();  t.eDx = (float)pt00.real();   // x' = M11 x + M12 y + dx
		t.eM12 = (float)pt10.imag();  t.eM22 = (float)pt01.imag();  t.eDy = (float)pt00.imag();   // y' = M21 x + M22 y + dy 

		// 2nd rgn
		HRGN ans = ::ExtCreateRegion( &t, nBytes, rd );

		// ato shori
		delete [] reinterpret_cast<BYTE*>(rd);
		return ans;
	}
};



//
// ܂ȂԂ鑋
//

//ToDo: ܂copyableȂvector.resizeł̂ł銴Ȃ̂Œ
class FoldableWindow
{
	bool erred;
public:
	FoldableWindow() : original_wnd( NULL ) {}

	void Init( HWND wnd )
	{
		RECT pos;
		::GetWindowRect( wnd, &pos );

		// {
		original_wnd = wnd;
		shape        = FoldedRect(pos);
		state        = TAIRA;

		// ݂̌`ۑƂ
		original_rgn = ::CreateRectRgn( 0, 0, pos.right-pos.left, pos.bottom-pos.top );
		int ret = ::GetWindowRgn( original_wnd, original_rgn );
		erred = ( ret==NULLREGION || ret==ERROR );
	}

	~FoldableWindow()
	{
		// n̔jA`󕜋A
		if( original_wnd )
		{
			if( erred )
			{
				::SetWindowRgn( original_wnd, NULL, TRUE );
				::DeleteObject( original_rgn );
			}
			else
				::SetWindowRgn( original_wnd, original_rgn, TRUE );
		}
	}

	bool mouse( const dcomp& prev_pt, const dcomp& pt )
	{
		// `ČvZ
		return calcShape(prev_pt, pt);
	}

	bool covers( const dcomp& pt ) { return shape.covers(pt); }
	bool rect_covers( const dcomp& pt ) { return shape.rect_covers(pt); }
	bool get_orime( dcomp& p1, dcomp& p2 ) { return shape.get_orime(p1,p2); }
	bool rebend( const dcomp& p1, const dcomp& p2 )
	{
		if(!shape.rebend(p1,p2))
			return false;
		state = ORETERU;
		return true;
	}

	bool is_taira() const
	{
		return state == TAIRA;
	}

	void updateShape( WindowBacking& back_r, bool updated );
private:
	bool calcShape( const dcomp& prev_pt, const dcomp& pt );

private:
	HWND       original_wnd;
	HRGN       original_rgn;
	FoldedRect shape;

private:
	enum State { TAIRA, MEKURI, ORETERU };
	State state;
};
